var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var buildEsm_exports = {};
__export(buildEsm_exports, {
  buildEsm: () => buildEsm
});
module.exports = __toCommonJS(buildEsm_exports);
var import_path = __toESM(require("path"));
var import_vite = require("vite");
var import_fast_glob = __toESM(require("fast-glob"));
async function buildEsm(cwd, userConfig, sourcemap = false, log) {
  log("build esm");
  const indexEntry = import_path.default.join(cwd, "src/index.ts").replaceAll(/\\/g, "/");
  const outDir = import_path.default.resolve(cwd, "es");
  await build(cwd, indexEntry, outDir, userConfig, sourcemap, log);
  const clientEntry = import_fast_glob.default.sync(["src/client/index.ts", "src/client.ts"], { cwd, absolute: true, onlyFiles: true })?.[0]?.replaceAll(/\\/g, "/");
  const clientOutDir = import_path.default.resolve(cwd, "es/client");
  if (clientEntry) {
    await build(cwd, clientEntry, clientOutDir, userConfig, sourcemap, log);
  }
  const pkg = require(import_path.default.join(cwd, "package.json"));
  if (pkg.name === "@nocobase/test") {
    const e2eEntry = import_path.default.join(cwd, "src/e2e/index.ts").replaceAll(/\\/g, "/");
    const e2eOutDir = import_path.default.resolve(cwd, "es/e2e");
    await build(cwd, e2eEntry, e2eOutDir, userConfig, sourcemap, log);
  }
}
function build(cwd, entry, outDir, userConfig, sourcemap = false, log) {
  const cwdWin = cwd.replaceAll(/\\/g, "/");
  const cwdUnix = cwd.replaceAll(/\//g, "\\");
  const external = function(id) {
    if (id.startsWith(".") || id.startsWith(cwdUnix) || id.startsWith(cwdWin)) {
      return false;
    }
    return true;
  };
  return (0, import_vite.build)(
    userConfig.modifyViteConfig({
      mode: process.env.NODE_ENV || "production",
      define: {
        "process.env.NODE_ENV": JSON.stringify(process.env.NODE_ENV || "production"),
        "process.env.__TEST__": false,
        "process.env.__E2E__": process.env.__E2E__ ? true : false
      },
      build: {
        minify: false,
        outDir,
        cssCodeSplit: true,
        emptyOutDir: true,
        sourcemap,
        lib: {
          entry,
          formats: ["es"],
          fileName: "index"
        },
        target: ["node16"],
        rollupOptions: {
          cache: true,
          treeshake: true,
          external
        }
      }
    })
  );
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  buildEsm
});
