var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var buildPlugin_exports = {};
__export(buildPlugin_exports, {
  buildPlugin: () => buildPlugin,
  buildPluginClient: () => buildPluginClient,
  buildPluginServer: () => buildPluginServer,
  buildServerDeps: () => buildServerDeps,
  deleteServerFiles: () => deleteServerFiles,
  writeExternalPackageVersion: () => writeExternalPackageVersion
});
module.exports = __toCommonJS(buildPlugin_exports);
var import_ncc = __toESM(require("@vercel/ncc"));
var import_plugin_react = __toESM(require("@vitejs/plugin-react"));
var import_chalk = __toESM(require("chalk"));
var import_fast_glob = __toESM(require("fast-glob"));
var import_fs_extra = __toESM(require("fs-extra"));
var import_path = __toESM(require("path"));
var import_tsup = require("tsup");
var import_vite = require("vite");
var import_vite_plugin_css_injected_by_js = __toESM(require("vite-plugin-css-injected-by-js"));
var import_constant = require("./constant");
var import_utils = require("./utils");
var import_buildPluginUtils = require("./utils/buildPluginUtils");
var import_getDepsConfig = require("./utils/getDepsConfig");
const validExts = [".ts", ".tsx", ".js", ".jsx", ".mjs"];
const serverGlobalFiles = ["src/**", "!src/client/**", ...import_constant.globExcludeFiles];
const clientGlobalFiles = ["src/**", "!src/server/**", ...import_constant.globExcludeFiles];
const sourceGlobalFiles = ["src/**/*.{ts,js,tsx,jsx,mjs}", "!src/**/__tests__"];
const external = [
  // nocobase
  "@nocobase/acl",
  "@nocobase/actions",
  "@nocobase/auth",
  "@nocobase/cache",
  "@nocobase/client",
  "@nocobase/database",
  "@nocobase/data-source-manager",
  "@nocobase/evaluators",
  "@nocobase/logger",
  "@nocobase/resourcer",
  "@nocobase/sdk",
  "@nocobase/schema",
  "@nocobase/server",
  "@nocobase/test",
  "@nocobase/utils",
  // @nocobase/auth
  "jsonwebtoken",
  // @nocobase/cache
  "cache-manager",
  // @nocobase/database
  "sequelize",
  "umzug",
  "async-mutex",
  // @nocobase/evaluators
  "@formulajs/formulajs",
  "mathjs",
  // @nocobase/logger
  "winston",
  "winston-daily-rotate-file",
  // koa
  "koa",
  "@koa/cors",
  "@koa/router",
  "multer",
  "@koa/multer",
  "koa-bodyparser",
  "koa-static",
  "koa-send",
  // react
  "react",
  "react-dom",
  "react/jsx-runtime",
  // react-router
  "react-router",
  "react-router-dom",
  // antd
  "antd",
  "antd-style",
  "@ant-design/icons",
  "@ant-design/cssinjs",
  // i18next
  "i18next",
  "react-i18next",
  // dnd-kit 相关
  "@dnd-kit/accessibility",
  "@dnd-kit/core",
  "@dnd-kit/modifiers",
  "@dnd-kit/sortable",
  "@dnd-kit/utilities",
  // formily 相关
  "@formily/antd-v5",
  "@formily/core",
  "@formily/react",
  "@formily/json-schema",
  "@formily/path",
  "@formily/validator",
  "@formily/shared",
  "@formily/reactive",
  "@formily/reactive-react",
  // utils
  "dayjs",
  "mysql2",
  "pg",
  "pg-hstore",
  "sqlite3",
  "supertest",
  "axios",
  "@emotion/css",
  "ahooks",
  "lodash",
  "china-division"
];
const pluginPrefix = (process.env.PLUGIN_PACKAGE_PREFIX || "@nocobase/plugin-,@tachybase/preset-,@nocobase/plugin-pro-,@hera/plugin-").split(",");
const target_dir = "dist";
function deleteServerFiles(cwd, log) {
  log("delete server files");
  const files = import_fast_glob.default.globSync(["*"], {
    cwd: import_path.default.join(cwd, target_dir),
    absolute: true,
    deep: 1,
    onlyFiles: true
  });
  const dirs = import_fast_glob.default.globSync(["*", "!client", "!node_modules"], {
    cwd: import_path.default.join(cwd, target_dir),
    absolute: true,
    deep: 1,
    onlyDirectories: true
  });
  [...files, ...dirs].forEach((item) => {
    import_fs_extra.default.removeSync(item);
  });
}
function writeExternalPackageVersion(cwd, log) {
  log("write external version");
  const sourceFiles = import_fast_glob.default.globSync(sourceGlobalFiles, { cwd, absolute: true }).map((item) => import_fs_extra.default.readFileSync(item, "utf-8"));
  const sourcePackages = (0, import_buildPluginUtils.getSourcePackages)(sourceFiles);
  const excludePackages = (0, import_buildPluginUtils.getExcludePackages)(sourcePackages, external, pluginPrefix);
  const data = excludePackages.reduce((prev, packageName) => {
    try {
      const depPkgPath = (0, import_getDepsConfig.getDepPkgPath)(packageName, cwd);
      const depPkg = require(depPkgPath);
      prev[packageName] = depPkg.version;
    } catch (error) {
      console.error(error);
    } finally {
      return prev;
    }
  }, {});
  const externalVersionPath = import_path.default.join(cwd, target_dir, "externalVersion.js");
  import_fs_extra.default.writeFileSync(externalVersionPath, `module.exports = ${JSON.stringify(data, null, 2)};`);
}
async function buildServerDeps(cwd, serverFiles, log) {
  log("build plugin server dependencies");
  const outDir = import_path.default.join(cwd, target_dir, "node_modules");
  const serverFileSource = serverFiles.filter((item) => validExts.includes(import_path.default.extname(item))).map((item) => import_fs_extra.default.readFileSync(item, "utf-8"));
  const sourcePackages = (0, import_buildPluginUtils.getSourcePackages)(serverFileSource);
  const includePackages = (0, import_buildPluginUtils.getIncludePackages)(sourcePackages, external, pluginPrefix);
  const excludePackages = (0, import_buildPluginUtils.getExcludePackages)(sourcePackages, external, pluginPrefix);
  let tips = [];
  if (includePackages.length) {
    tips.push(
      `These packages ${import_chalk.default.yellow(includePackages.join(", "))} will be ${import_chalk.default.italic(
        "bundled"
      )} to dist/node_modules.`
    );
  }
  if (excludePackages.length) {
    tips.push(`These packages ${import_chalk.default.yellow(excludePackages.join(", "))} will be ${import_chalk.default.italic("exclude")}.`);
  }
  tips.push(`For more information, please refer to: ${import_chalk.default.blue("https://docs.nocobase.com/development/deps")}.`);
  log(tips.join(" "));
  if (!includePackages.length)
    return;
  const deps = (0, import_getDepsConfig.getDepsConfig)(cwd, outDir, includePackages, external);
  for (const dep of Object.keys(deps)) {
    const { outputDir, mainFile, pkg, nccConfig, depDir } = deps[dep];
    const outputPackageJson = import_path.default.join(outputDir, "package.json");
    if (import_fs_extra.default.existsSync(outputPackageJson)) {
      const outputPackage = require(outputPackageJson);
      if (outputPackage.version === pkg.version) {
        continue;
      }
    }
    await import_fs_extra.default.copy(depDir, outputDir, { errorOnExist: false });
    const deleteFiles = import_fast_glob.default.sync(
      [
        "./**/*.map",
        "./**/*.js.map",
        "./**/*.md",
        "./**/*.mjs",
        "./**/*.png",
        "./**/*.jpg",
        "./**/*.jpeg",
        "./**/*.gif",
        "./**/*/.bin",
        "./**/*/bin",
        "./**/*/LICENSE",
        "./**/*/tsconfig.json"
      ],
      { cwd: outputDir, absolute: true }
    );
    deleteFiles.forEach((file) => {
      import_fs_extra.default.unlinkSync(file);
    });
    await (0, import_ncc.default)(dep, nccConfig).then(
      ({ code, assets }) => {
        import_fs_extra.default.writeFileSync(mainFile, code, "utf-8");
        Object.entries(assets).forEach(([name, item]) => {
          import_fs_extra.default.writeFileSync(import_path.default.join(outputDir, name), item.source, {
            encoding: "utf-8",
            mode: item.permissions
          });
        });
        import_fs_extra.default.writeFileSync(
          outputPackageJson,
          JSON.stringify({
            ...pkg,
            _lastModified: (/* @__PURE__ */ new Date()).toISOString()
          }),
          "utf-8"
        );
      }
    );
  }
}
async function buildPluginServer(cwd, userConfig, sourcemap, log) {
  log("build plugin server source");
  const packageJson = (0, import_utils.getPackageJson)(cwd);
  const serverFiles = import_fast_glob.default.globSync(serverGlobalFiles, { cwd, absolute: true });
  (0, import_buildPluginUtils.buildCheck)({ cwd, packageJson, entry: "server", files: serverFiles, log });
  const otherExts = Array.from(new Set(serverFiles.map((item) => import_path.default.extname(item)).filter((item) => !import_constant.EsbuildSupportExts.includes(item))));
  if (otherExts.length) {
    log("%s will not be processed, only be copied to the dist directory.", import_chalk.default.yellow(otherExts.join(",")));
  }
  deleteServerFiles(cwd, log);
  await (0, import_tsup.build)(userConfig.modifyTsupConfig({
    entry: serverFiles,
    splitting: false,
    clean: false,
    bundle: false,
    silent: true,
    treeshake: false,
    target: "node16",
    sourcemap,
    outDir: import_path.default.join(cwd, target_dir),
    format: "cjs",
    skipNodeModulesBundle: true,
    loader: {
      ...otherExts.reduce((prev, cur) => ({ ...prev, [cur]: "copy" }), {}),
      ".json": "copy"
    }
  }));
  await buildServerDeps(cwd, serverFiles, log);
}
async function buildPluginClient(cwd, userConfig, sourcemap, log) {
  log("build plugin client");
  const packageJson = (0, import_utils.getPackageJson)(cwd);
  const clientFiles = import_fast_glob.default.globSync(clientGlobalFiles, { cwd, absolute: true });
  const clientFileSource = clientFiles.map((item) => import_fs_extra.default.readFileSync(item, "utf-8"));
  const sourcePackages = (0, import_buildPluginUtils.getPackagesFromFiles)(clientFileSource);
  const excludePackages = (0, import_buildPluginUtils.getExcludePackages)(sourcePackages, external, pluginPrefix);
  (0, import_buildPluginUtils.checkRequire)(clientFiles, log);
  (0, import_buildPluginUtils.buildCheck)({ cwd, packageJson, entry: "client", files: clientFiles, log });
  const outDir = import_path.default.join(cwd, target_dir, "client");
  const globals = excludePackages.reduce((prev, curr) => {
    if (curr.startsWith("@nocobase") || curr.startsWith("@hera")) {
      prev[`${curr}/client`] = curr;
    }
    prev[curr] = curr;
    return prev;
  }, {});
  const entry = import_fast_glob.default.globSync("src/client/index.{ts,tsx,js,jsx}", { absolute: true, cwd });
  const outputFileName = "index.js";
  await (0, import_vite.build)(userConfig.modifyViteConfig({
    mode: process.env.NODE_ENV || "production",
    define: {
      "process.env.NODE_ENV": JSON.stringify(process.env.NODE_ENV || "production"),
      "process.env.__TEST__": false,
      "process.env.__E2E__": process.env.__E2E__ ? true : false
    },
    logLevel: "warn",
    build: {
      minify: process.env.NODE_ENV === "production",
      outDir,
      cssCodeSplit: false,
      emptyOutDir: true,
      sourcemap,
      lib: {
        entry,
        formats: ["umd"],
        name: packageJson.name,
        fileName: () => outputFileName
      },
      target: ["es2015", "edge88", "firefox78", "chrome87", "safari14"],
      rollupOptions: {
        cache: true,
        external: [...Object.keys(globals), "react", "react/jsx-runtime"],
        output: {
          exports: "named",
          globals: {
            react: "React",
            "react/jsx-runtime": "jsxRuntime",
            ...globals
          }
        }
      }
    },
    plugins: [
      (0, import_plugin_react.default)(),
      (0, import_vite_plugin_css_injected_by_js.default)({ styleId: packageJson.name })
    ]
  }));
  (0, import_buildPluginUtils.checkFileSize)(outDir, log);
}
async function buildPlugin(cwd, userConfig, sourcemap, log) {
  await buildPluginClient(cwd, userConfig, sourcemap, log);
  await buildPluginServer(cwd, userConfig, sourcemap, log);
  writeExternalPackageVersion(cwd, log);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  buildPlugin,
  buildPluginClient,
  buildPluginServer,
  buildServerDeps,
  deleteServerFiles,
  writeExternalPackageVersion
});
